# -*- Makefile -*-

ifeq (CYGWIN, $(findstring CYGWIN, $(shell uname)))
  OSNAME = Cygwin			# same as 'uname -o' on Cygwin
else
  OSNAME = $(shell uname)
endif
# must strip Cygwin to match below (don't add comment after OS = below!!!)
OS = $(strip $(OSNAME))

SRCS	= base_t.cpp
OBJS	= $(SRCS:.cpp=.o)
LOBJS	= $(SRCS:.cpp=.lo)

LIBBASE = base_t
LIBNAME	= lib$(LIBBASE)

CXXFLAGS	+= -D_REENTRANT -g -Wall -Wshadow
LCXXFLAGS	= $(CXXFLAGS)

ifeq ($(OS),Cygwin)
  AR_FLAGS = crv
else
  LCXXFLAGS		+= -fPIC
  SHARED_LIBRARY	= $(LIBNAME).so
  STATIC_LIBRARY	= $(LIBNAME).a
endif

LDFLAGS	+= -shared

ifeq ($(OS),Cygwin)

all:	cyg$(LIBBASE).dll

$(LIBNAME).a $(LIBNAME).a.dll.a cyg$(LIBBASE).dll:	$(OBJS)
	${AR} ${AR_FLAGS} $(LIBNAME).a $(OBJS)
	${CXX} -shared -g -o cyg$(LIBBASE).dll \
	      -Wl,--out-implib=$(LIBNAME).dll.a \
	      -Wl,--export-all-symbols \
	      -Wl,--enable-auto-import \
	      -Wl,--whole-archive $(LIBNAME).a \
	      -Wl,--no-whole-archive 

else

all:	$(SHARED_LIBRARY) $(STATIC_LIBRARY)

%.lo:	%.cpp
	$(CXX) $(CPPFLAGS) $(LCXXFLAGS) -o $@ -c $<

# output to /dev/null so don't get messages twice
%.o:	%.cpp
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -o $@ -c $< >/dev/null 2>&1

# target to build shared library
$(SHARED_LIBRARY): $(LOBJS)
	$(CXX) $(LDFLAGS) -o $@ $^

# target to build static library
$(STATIC_LIBRARY): $(OBJS)
	$(AR) $(ARFLAGS) $@ $^

endif
